//
//  InstaTwitViewController.m

#import "InstaTwitViewController.h"
#import "SA_OAuthTwitterEngine.h"


/* Define the constants below with the Twitter 
   Key and Secret for your application. Create
   Twitter OAuth credentials by registering your
   application as an OAuth Client here: http://twitter.com/apps/new
 */

#define kOAuthConsumerKey				@""	    // 여기에 Consumer Key를 복사해 넣으세요.  
#define kOAuthConsumerSecret			@""		// 여기에 Consumer Secret을 복사해 넣으세요.

@implementation InstaTwitViewController
@synthesize tweetPicker, notesField; 

#pragma mark Custom Methods

- (IBAction) sendButtonTapped: (id) sender;
{
	NSString* themessage = [NSString stringWithFormat:@"%@. I'm %@ and feeling %@ about it.",
							notesField.text ? notesField.text : @"",
							[activities objectAtIndex:[tweetPicker selectedRowInComponent:0]],
							[feelings objectAtIndex:[tweetPicker selectedRowInComponent:1]]];
	NSLog(@"%@", themessage);
	
	//TWITTER BLACK MAGIC
	[_engine sendUpdate:themessage];
	//END TWITTER BLACK MAGIC
}

-(IBAction) textFieldDoneEditing:(id) sender
{
	[notesField resignFirstResponder];
}

#pragma mark ViewController Lifecycle

- (void)viewDidLoad {
	activities = [[NSArray alloc] initWithObjects:@"sleeping", @"eating", @"working", @"thinking", @"crying", @"begging",
				  @"leaving", @"shopping", @"hello worlding", nil];
	feelings = [[NSArray alloc] initWithObjects:@"awesome", @"sad", @"happy", @"ambivalent", @"nausous", @"psyched",
				@"confused", @"hopeful", @"anxious", nil];
    [super viewDidLoad];
}

- (void)viewDidAppear: (BOOL)animated {
		
	if(!_engine){
		_engine = [[SA_OAuthTwitterEngine alloc] initOAuthWithDelegate:self];
		_engine.consumerKey    = kOAuthConsumerKey;
		_engine.consumerSecret = kOAuthConsumerSecret;	
	}
	
	UIViewController *controller = [SA_OAuthTwitterController controllerToEnterCredentialsWithTwitterEngine:_engine delegate:self];
	
	if (controller){
		[self presentModalViewController: controller animated: YES];
	}

}
	   
- (void)viewDidUnload {	
	[tweetPicker release];
	tweetPicker = nil;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)dealloc {
	[activities release];
	[feelings release];
	[notesField release];
	[_engine release];
	[tweetPicker release];
    [super dealloc];
}

#pragma mark UIPickerView Delegate and DataSource
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView{
	return 2;
}

- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent :(NSInteger)component {
	if (component == 0) {
		return [activities count];
	}
	else {
		return [feelings count];
	}
}

-(NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent: (NSInteger)component{
	switch (component) {
		case 0:
			return [activities objectAtIndex:row];
		case 1:
			return [feelings objectAtIndex:row];
	}
	return nil;
}

//=============================================================================================================================
#pragma mark SA_OAuthTwitterEngineDelegate
- (void) storeCachedTwitterOAuthData: (NSString *) data forUsername: (NSString *) username {
	NSUserDefaults			*defaults = [NSUserDefaults standardUserDefaults];
	
	[defaults setObject: data forKey: @"authData"];
	[defaults synchronize];
}

- (NSString *) cachedTwitterOAuthDataForUsername: (NSString *) username {
	return [[NSUserDefaults standardUserDefaults] objectForKey: @"authData"];
}

//=============================================================================================================================
#pragma mark TwitterEngineDelegate
- (void) requestSucceeded: (NSString *) requestIdentifier {
	NSLog(@"Request %@ succeeded", requestIdentifier);
}

- (void) requestFailed: (NSString *) requestIdentifier withError: (NSError *) error {
	NSLog(@"Request %@ failed with error: %@", requestIdentifier, error);
}



@end
